/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 24 de Marzo de 2001

Simulacin:  AlgEvo003
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Hay un Universo
Universo tiene ambientes
Universo tiene tipos de materiales
Hay materiales de cada tipo dispersos por todo el Universo
El ser vivo es la cooperacin entre materiales

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Material.h"

void Material::vInicia(unsigned int iID, unsigned int iXmin, unsigned int iYmin, unsigned int iXmax, unsigned int iYmax, unsigned int iMaxTipMat)
{
	/* ID del material */
	m_iIDmat = iID;

	/* De que tipo de material es? */
	m_iTipMaterial = rand() % iMaxTipMat;

	/* Posiciona al azar el material entre los lmites del Universo */
	m_iPosX = rand() % (iXmax - iXmin) + iXmin;
	m_iPosY = rand() % (iYmax - iYmin) + iYmin;

	/* Al principio no esta usado por ningun organismo */
	m_cUsado = MAT_NOOCUPADO;
};


