/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 24 de Marzo de 2001

Simulacin:  AlgEvo003
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Hay un Universo
Universo tiene ambientes
Universo tiene tipos de materiales
Hay materiales de cada tipo dispersos por todo el Universo
El ser vivo es la cooperacin entre materiales
Hay tipos de seres vivos (el concepto de especie).
*/

#ifndef PARAMETRO
#include "Parametro.h"
#endif

#define TIPOORGANISMO 1

// Tipo de Organismo (especie)
// Tiene la lista de tipo y cantidad de materiales que necesita un ser vivo */
class TipoOrg
{
public:
	/* Identificador de Tipo Organismo */
	unsigned int m_iIdTipOrg;

	/* Lista los tipos de materiales que compone el organismo */
	unsigned int *m_iIdTipMat;
	
	/* Nmero de materiales por tipo */
	unsigned int *iNumMaterialporTipo;

	//Tolerancia mnima de energa (se calcula cercano a la especie)
	int m_iToleranciaMin;

	//Tolerancia mxima de energa (se calcula cercano a la especie)
	int m_iToleranciaMax;
};
